﻿using System;
using System.Linq;
using System.IO.Ports;
using System.Windows.Forms;


public partial class KeiganMotor_USB
{
    public SerialPort serialPort;
    public UInt16 commandID;
    delegate void dataReceived(KeiganMotor_USB motor);

    public KeiganMotor_USB(string portName)
	{
        this.serialPort = new SerialPort();
        // KeiganMotor KM-1 needs the following UART settings.
        serialPort.PortName = portName;
        serialPort.BaudRate = 115200;
        serialPort.DataBits = 8;
        serialPort.DtrEnable = true;
        serialPort.Handshake = Handshake.RequestToSend;
        serialPort.Parity = Parity.None;
        serialPort.RtsEnable = true;
        serialPort.StopBits = StopBits.One;

        serialPort.DataReceived += new SerialDataReceivedEventHandler(DataReceivedHandler);

    }
    private static void DataReceivedHandler(
                    object sender,
                    SerialDataReceivedEventArgs e)
    {

        //SerialPort sp = (SerialPort)sender;
        ////string indata = sp.ReadExisting();
        //byte b = sp.ReadByte();
        //Console.WriteLine("Data Received:");
        //Console.Write(indata);
    }


    public bool Open()
    {
        try
        {
            serialPort.Open();
        }
        catch (Exception ex)
        {
            MessageBox.Show(ex.Message);
            return false;
        }
        return true;
    }


    public bool Close()
    {
        try
        {
            serialPort.Close();
        }
        catch (Exception ex)
        {
            MessageBox.Show(ex.Message);
            return false;
        }
        return true;
    }

// Receive Data from KeiganMotor



    public byte[] GetIDBytes()
    {
        byte[] a = UInt16ToBytes(this.commandID);

        if (this.commandID < 0xFFFF)
        {
            this.commandID++;
        }
        else
        {
            this.commandID = 0;
        }
        return a;
    }




}
