﻿using System;
using System.Linq;
using System.IO.Ports;
using System.Windows.Forms;

public partial class KeiganMotor_USB
{
    // バイト列と型の相互変換
    enum Endian
    {
        Little, Big
    }

    static byte[] CorrectEndianBytes(byte[] bytes, Endian endian)
    {
        if (BitConverter.IsLittleEndian ^ (endian == Endian.Little))
            return bytes.Reverse().ToArray();
        else
            return bytes;
    }

    static byte[] FloatToBytes(float value)
    {
        return CorrectEndianBytes(BitConverter.GetBytes(value), Endian.Big);

    }

    static byte[] UInt16ToBytes(UInt16 value)
    {
        return CorrectEndianBytes(BitConverter.GetBytes(value), Endian.Big);

    }

    static byte[] UInt32ToBytes(UInt32 value)
    {
        return CorrectEndianBytes(BitConverter.GetBytes(value), Endian.Big);

    }

    static float BytesToFloat(byte[] bytes)
    {
        byte[] correctedBytes = bytes.Reverse().ToArray();
        if (bytes.Count() == sizeof(float))
        {
            return BitConverter.ToSingle(correctedBytes, 0);
        }
        else
        {
            return 0;
        }
    }

    static UInt16 BytesToUInt16(byte[] bytes)
    {
        byte[] correctedBytes = bytes.Reverse().ToArray();
        if (bytes.Count() == sizeof(UInt16))
        {
            return BitConverter.ToUInt16(correctedBytes, 0);
        }
        else
        {
            return 0;
        }
    }

    static UInt32 BytesToUInt32(byte[] bytes)
    {
        byte[] correctedBytes = bytes.Reverse().ToArray();
        if (bytes.Count() == sizeof(UInt32))
        {
            return BitConverter.ToUInt32(correctedBytes, 0);
        }
        else
        {
            return 0;
        }
    }
}
